## pve-ha-manager 4.0.6

=== Makefile ===
PACKAGE=pve-ha-manager
SIMPACKAGE=pve-ha-simulator

PREFIX=/usr
BINDIR=$(PREFIX)/bin
SBINDIR=$(PREFIX)/sbin
MANDIR=$(PREFIX)/share/man
DOCDIR=$(PREFIX)/share/doc/$(PACKAGE)
SIMDOCDIR=$(PREFIX)/share/doc/$(SIMPACKAGE)
MAN1DIR=$(MANDIR)/man1/
MAN8DIR=$(MANDIR)/man8/
BASHCOMPLDIR=$(PREFIX)/share/bash-completion/completions/
ZSHCOMPLDIR=$(PREFIX)/share/zsh/vendor-completions/
export PERLDIR=$(PREFIX)/share/perl5

-include /usr/share/pve-doc-generator/pve-doc-generator.mk

all: watchdog-mux

pve-ha-crm.bash-completion:
	PVE_GENERATING_DOCS=1 perl -I. -T -e "use PVE::Service::pve_ha_crm; PVE::Service::pve_ha_crm->generate_bash_completions();" >$@.tmp
	mv $@.tmp $@

pve-ha-lrm.bash-completion:
	PVE_GENERATING_DOCS=1 perl -I. -T -e "use PVE::Service::pve_ha_lrm; PVE::Service::pve_ha_lrm->generate_bash_completions();" >$@.tmp
	mv $@.tmp $@

ha-manager.bash-completion:
	PVE_GENERATING_DOCS=1 perl -I. -T -e "use PVE::CLI::ha_manager; PVE::CLI::ha_manager->generate_bash_completions();" >$@.tmp
	mv $@.tmp $@

pve-ha-crm.zsh-completion:
	PVE_GENERATING_DOCS=1 perl -I. -T -e "use PVE::Service::pve_ha_crm; PVE::Service::pve_ha_crm->generate_zsh_completions();" >$@.tmp
	mv $@.tmp $@

pve-ha-lrm.zsh-completion:
	PVE_GENERATING_DOCS=1 perl -I. -T -e "use PVE::Service::pve_ha_lrm; PVE::Service::pve_ha_lrm->generate_zsh_completions();" >$@.tmp
	mv $@.tmp $@

ha-manager.zsh-completion:
	PVE_GENERATING_DOCS=1 perl -I. -T -e "use PVE::CLI::ha_manager; PVE::CLI::ha_manager->generate_zsh_completions();" >$@.tmp
	mv $@.tmp $@

watchdog-mux: watchdog-mux.c
	gcc watchdog-mux.c -o watchdog-mux -Wall -Wl,-z,relro

.PHONY: install
install: watchdog-mux pve-ha-crm pve-ha-lrm ha-manager.1 pve-ha-crm.8 pve-ha-lrm.8 ha-manager.bash-completion pve-ha-lrm.bash-completion \
	    pve-ha-crm.bash-completion ha-manager.zsh-completion pve-ha-lrm.zsh-completion pve-ha-crm.zsh-completion pve-ha-simulator
	PVE_GENERATING_DOCS=1 perl -I. -T -e "use PVE::Service::pve_ha_crm; PVE::Service::pve_ha_crm->verify_api();"
	PVE_GENERATING_DOCS=1 perl -I. -T -e "use PVE::Service::pve_ha_lrm; PVE::Service::pve_ha_lrm->verify_api();"
	PVE_GENERATING_DOCS=1 perl -I. -T -e "use PVE::CLI::ha_manager; PVE::CLI::ha_manager->verify_api();"
	install -d $(DESTDIR)$(SBINDIR)
	install -m 0755 pve-ha-crm $(DESTDIR)$(SBINDIR)
	install -m 0755 pve-ha-lrm $(DESTDIR)$(SBINDIR)
	install -m 0755 ha-manager $(DESTDIR)$(SBINDIR)
	install -m 0755 watchdog-mux $(DESTDIR)$(SBINDIR)
	install -d $(DESTDIR)$(BINDIR)
	install -m 0755 pve-ha-simulator $(DESTDIR)$(BINDIR)
	install -m 0644 -D pve-ha-crm.bash-completion $(DESTDIR)$(BASHCOMPLDIR)/pve-ha-crm
	install -m 0644 -D pve-ha-lrm.bash-completion $(DESTDIR)$(BASHCOMPLDIR)/pve-ha-lrm
	install -m 0644 -D ha-manager.bash-completion $(DESTDIR)$(BASHCOMPLDIR)/ha-manager
	install -m 0644 -D pve-ha-crm.zsh-completion $(DESTDIR)$(ZSHCOMPLDIR)/_pve-ha-crm
	install -m 0644 -D pve-ha-lrm.zsh-completion $(DESTDIR)$(ZSHCOMPLDIR)/_pve-ha-lrm
	install -m 0644 -D ha-manager.zsh-completion $(DESTDIR)$(ZSHCOMPLDIR)/_ha-manager
	make -C PVE install
	make -C PVE PERLDIR=$(PREFIX)/share/$(SIMPACKAGE) installsim
	install -d $(DESTDIR)/$(MAN8DIR)
	install -m 0644 pve-ha-crm.8 $(DESTDIR)/$(MAN8DIR)
	gzip -9 $(DESTDIR)/$(MAN8DIR)/pve-ha-crm.8
	install -m 0644 pve-ha-lrm.8 $(DESTDIR)/$(MAN8DIR)
	gzip -9 $(DESTDIR)/$(MAN8DIR)/pve-ha-lrm.8
	install -d $(DESTDIR)/$(MAN1DIR)
	install -m 0644 ha-manager.1 $(DESTDIR)/$(MAN1DIR)
	gzip -9 $(DESTDIR)/$(MAN1DIR)/ha-manager.1
	$(MAKE) -C templates $@

.PHONY: test
test: 
	make -C test test

.PHONY: clean
clean:
	rm -f *.xml.tmp *.1 *.5 *.8 *{synopsis,opts}.adoc docinfo.xml
	make -C test clean
	rm -rf watchdog-mux *.1.pod *.1.gz *.bash-completion *.zsh-completion *.tmp

.PHONY: distclean
distclean: clean

=== PVE/Makefile ===
.PHONY: install
install:
	install -d -m 0755 ${DESTDIR}${PERLDIR}/PVE
	make -C HA install
	make -C API2 install
	make -C CLI install
	make -C Service install

.PHONY: installsim
installsim:
	install -d -m 0755 ${DESTDIR}${PERLDIR}/PVE
	make -C HA installsim

=== templates/Makefile ===
NOTIFICATION_TEMPLATES=							\
	default/fencing-subject.txt.hbs				\
	default/fencing-body.txt.hbs				\
	default/fencing-body.html.hbs				\

.PHONY: install
install:
	install -dm 0755 $(DESTDIR)/usr/share/pve-manager/templates/default
	$(foreach i,$(NOTIFICATION_TEMPLATES), \
	    install -m644 $(i) $(DESTDIR)/usr/share/pve-manager/templates/$(i) ;)

=== test/Makefile ===
all:


.PHONY: test
test:
	@echo "-- start regression tests --"
	./test_failover1.pl
	./ha-tester.pl
	./test_fence_config.pl
	@echo "-- end regression tests (success) --"

.PHONY: clean
clean:
	rm -rf *~ test-*/log  test-*/*~ test-*/status \
	fence_cfgs/*.cfg.commands fence_cfgs/*.write

=== PVE/API2/Makefile ===

.PHONY: install
install:
	install -d -m 0755 ${DESTDIR}${PERLDIR}/PVE/API2
	make -C HA install

=== PVE/CLI/Makefile ===
SOURCES=ha_manager.pm

.PHONY: install
install: ${SOURCES}
	install -d -m 0755 ${DESTDIR}${PERLDIR}/PVE/CLI
	for i in ${SOURCES}; do install -D -m 0644 $$i ${DESTDIR}${PERLDIR}/PVE/CLI/$$i; done

=== PVE/HA/Makefile ===
SIM_SOURCES=CRM.pm Env.pm Groups.pm Resources.pm LRM.pm Manager.pm \
	NodeStatus.pm Tools.pm FenceConfig.pm Fence.pm Usage.pm

SOURCES=${SIM_SOURCES} Config.pm

.PHONY: install
install:
	install -d -m 0755 ${DESTDIR}${PERLDIR}/PVE/HA
	for i in ${SOURCES}; do install -D -m 0644 $$i ${DESTDIR}${PERLDIR}/PVE/HA/$$i; done
	make -C Resources install
	make -C Usage install
	make -C Env install

.PHONY: installsim
installsim:
	install -d -m 0755 ${DESTDIR}${PERLDIR}/PVE/HA
	for i in ${SIM_SOURCES}; do install -D -m 0644 $$i ${DESTDIR}${PERLDIR}/PVE/HA/$$i; done
	make -C Sim install

=== PVE/Service/Makefile ===
SOURCES=pve_ha_lrm.pm pve_ha_crm.pm

.PHONY: install
install: ${SOURCES}
	install -d -m 0755 ${DESTDIR}${PERLDIR}/PVE/Service
	for i in ${SOURCES}; do install -D -m 0644 $$i ${DESTDIR}${PERLDIR}/PVE/Service/$$i; done

=== PVE/API2/HA/Makefile ===
SOURCES=Resources.pm Groups.pm Status.pm

.PHONY: install
install:
	install -d -m 0755 ${DESTDIR}${PERLDIR}/PVE/API2/HA
	for i in ${SOURCES}; do install -D -m 0644 $$i ${DESTDIR}${PERLDIR}/PVE/API2/HA/$$i; done

=== PVE/HA/Env/Makefile ===


.PHONY: install
install:
	install -D -m 0644 PVE2.pm ${DESTDIR}${PERLDIR}/PVE/HA/Env/PVE2.pm

=== PVE/HA/Resources/Makefile ===
SOURCES=PVEVM.pm PVECT.pm

.PHONY: install
install:
	install -d -m 0755 ${DESTDIR}${PERLDIR}/PVE/HA/Resources
	for i in ${SOURCES}; do install -D -m 0644 $$i ${DESTDIR}${PERLDIR}/PVE/HA/Resources/$$i; done

=== PVE/HA/Sim/Makefile ===
SOURCES=Env.pm Hardware.pm TestEnv.pm TestHardware.pm RTEnv.pm RTHardware.pm Resources.pm

.PHONY: install
install:
	install -d -m 0755 ${DESTDIR}${PERLDIR}/PVE/HA/Sim
	for i in ${SOURCES}; do install -D -m 0644 $$i ${DESTDIR}${PERLDIR}/PVE/HA/Sim/$$i; done
	make -C Resources install

=== debian/changelog ===
pve-ha-manager (4.0.6) bookworm; urgency=medium

  * tools: group verbose description: explicitly state that higher number
    means a higher priority

  * fix #5243: make CRM go idle after ~15 min of no service being configured.
    This is mostly cosmetic as the CRM never needed to trigger self-fencing on
    quorum-loss anyway, as all state under the CRM's control is managed by the
    pmxcfs, which is already protected by quorum and cluster synchronisation.

  * crm: get active if there are pending CRM commands and it seems that no CRM
    is already active. This ensures any CRM command, like disabling the
    node-maintenance mode is properly processed. Currently this is mostly
    cosmetic though, but not unimportant as we show the maintenance state in
    the UI since not that long ago.

  * crm: get active if there are nodes that probably need to leave maintenance
    mode. This is very similar to the point above but is less likely to
    trigger if just CLI/API is used.

 -- Proxmox Support Team <support@proxmox.com>  Sun, 17 Nov 2024 20:36:17 +0100

pve-ha-manager (4.0.5) bookworm; urgency=medium

  * env: notify: use named templates instead of passing template strings

 -- Proxmox Support Team <support@proxmox.com>  Tue, 04 Jun 2024 11:10:05 +0200

pve-ha-manager (4.0.4) bookworm; urgency=medium

  * d/postinst: make deb-systemd-invoke non-fatal

 -- Proxmox Support Team <support@proxmox.com>  Mon, 22 Apr 2024 13:47:18 +0200

pve-ha-manager (4.0.3) bookworm; urgency=medium

  * manager: send notifications via new notification module

  * fix #4984: manager: add service to migration-target usage only if online

  * crs: avoid auto-vivification when adding node to service usage

 -- Proxmox Support Team <support@proxmox.com>  Fri, 17 Nov 2023 14:49:03 +0100

pve-ha-manager (4.0.2) bookworm; urgency=medium

  * cluster resource manager: clear stale maintenance node, which can be
    caused by simultaneous cluster shutdown

 -- Proxmox Support Team <support@proxmox.com>  Tue, 13 Jun 2023 08:35:52 +0200

pve-ha-manager (4.0.1) bookworm; urgency=medium

  * test, simulator: make it possible to add already running service

  * lrm: do not migrate via rebalance-on-start if service already running upon
    rebalance on start

  * api: fix/add return description for status endpoint

  * resources: pve: avoid relying on internal configuration details, use new
    helpers in pve-container and qemu-server

 -- Proxmox Support Team <support@proxmox.com>  Fri, 09 Jun 2023 10:41:06 +0200

pve-ha-manager (4.0.0) bookworm; urgency=medium

  * re-build for Proxmox VE 8 / Debian 12 Bookworm

 -- Proxmox Support Team <support@proxmox.com>  Wed, 24 May 2023 19:26:51 +0200

pve-ha-manager (3.6.1) bullseye; urgency=medium

  * cli: assert that node exist when changing CRS request state to avoid
    creating a phantom node by mistake

  * manager: ensure node-request state gets transferred to new active CRM, so
    that the request for (manual) maintenance mode is upheld, even if the node
    that is in maintenace mode is also the current active CRM and gets
    rebooted.

  * lrm: ignore shutdown policy if (manual) maintenance mode is requested to
    avoid exiting from maintenance mode to early.

 -- Proxmox Support Team <support@proxmox.com>  Thu, 20 Apr 2023 14:16:14 +0200

pve-ha-manager (3.6.0) bullseye; urgency=medium

  * fix #4371: add CRM command to switch an online node manually into
    maintenance (without reboot), moving away all active services, but
    automatically migrate them back once the maintenance mode is disabled
    again.

  * manager: service start: make EWRONG_NODE a non-fatal error, but try to
    find its the actual node the service is residing on

  * manager: add new intermediate 'request_started' state for stop->start
    transitions

  * request start: optionally enable automatic selection of the best rated
    node by the CRS on service start up, bypassing the very high priority of
    the current node on which a service is located.

 -- Proxmox Support Team <support@proxmox.com>  Mon, 20 Mar 2023 13:38:26 +0100

pve-ha-manager (3.5.1) bullseye; urgency=medium

  * manager: update crs scheduling mode once per round to avoid the need for a
    restart of the currently active manager.

  * api: status: add CRS info to manager if not set to default

 -- Proxmox Support Team <support@proxmox.com>  Sat, 19 Nov 2022 15:51:11 +0100

pve-ha-manager (3.5.0) bullseye; urgency=medium

  * env: datacenter config: include crs (cluster-resource-scheduling) setting

  * manager: use static resource scheduler when configured

  * manager: avoid scoring nodes if maintenance fallback node is valid

  * manager: avoid scoring nodes when not trying next and current node is
    valid

  * usage: static: use service count on nodes as a fallback

 -- Proxmox Support Team <support@proxmox.com>  Fri, 18 Nov 2022 15:02:55 +0100

pve-ha-manager (3.4.0) bullseye; urgency=medium

  * switch to native version formatting

  * fix accounting of online services when moving services due to their source
    node going gracefully nonoperational (maintenance mode). This ensures a
    better balance of services on the cluster after such an operation.

 -- Proxmox Support Team <support@proxmox.com>  Fri, 22 Jul 2022 09:21:20 +0200

pve-ha-manager (3.3-4) bullseye; urgency=medium

  * lrm: fix getting stuck on restart due to finished worker state not
    being collected

 -- Proxmox Support Team <support@proxmox.com>  Wed, 27 Apr 2022 14:01:55 +0200

pve-ha-manager (3.3-3) bullseye; urgency=medium

  * lrm: avoid possible job starvation on huge workloads

  * lrm: increase run_worker loop-time for doing actually work to 80%
    duty-cycle

 -- Proxmox Support Team <support@proxmox.com>  Thu, 20 Jan 2022 18:05:33 +0100

pve-ha-manager (3.3-2) bullseye; urgency=medium

  * fix #3826: fix restarting LRM/CRM when triggered by package management
    system due to other updates



=== debian/control ===
Source: pve-ha-manager
Section: perl
Priority: extra
Maintainer: Proxmox Support Team <support@proxmox.com>
Build-Depends: debhelper-compat (= 13),
               libglib-perl,
               libgtk3-perl,
               libpve-access-control,
               libpve-cluster-perl,
               libpve-common-perl,
               libpve-notify-perl,
               libpve-rs-perl (>= 0.7.3),
               lintian,
               pve-cluster,
               pve-doc-generator (>= 5.3-3),
Standards-Version: 4.5.1

Package: pve-ha-manager
Section: perl
Priority: optional
Architecture: any
Depends: libjson-perl,
         libpve-cluster-perl,
         libpve-common-perl,
         libpve-notify-perl,
         libpve-rs-perl (>= 0.7.3),
         pve-cluster (>= 3.0-17),
         pve-container (>= 5.0.1),
         qemu-server (>= 8.0.2),
         systemd,
         ${misc:Depends},
         ${perl:Depends},
         ${shlibs:Depends},
Conflicts: watchdog,
Description: Proxmox VE HA Manager
 HA Manager Proxmox VE.

Package: pve-ha-simulator
Section: perl
Priority: optional
Architecture: all
Depends: libclone-perl,
         libdevel-cycle-perl,
         libencode-locale-perl,
         libfilesys-df-perl,
         libglib-perl,
         libgtk3-perl,
         libhttp-message-perl,
         libjson-perl,
         libnet-ip-perl,
         libstring-shellquote-perl,
         liburi-perl,
         ${misc:Depends},
         ${perl:Depends},
Description: Proxmox VE HA Simulator
 This is a simple GUI to simulate the behavior of a Proxmox VE HA cluster.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

override_dh_install:
	# embed copies of libpve-common-perl files needed by simulator
	install -d -m 0755 debian/tmp/usr/share/pve-ha-simulator/PVE
	install -m 0644 \
		/usr/share/perl5/PVE/Exception.pm \
		/usr/share/perl5/PVE/JSONSchema.pm \
		/usr/share/perl5/PVE/ProcFSTools.pm \
		/usr/share/perl5/PVE/SafeSyslog.pm \
		/usr/share/perl5/PVE/SectionConfig.pm \
		/usr/share/perl5/PVE/Syscall.pm \
		/usr/share/perl5/PVE/Tools.pm \
		debian/tmp/usr/share/pve-ha-simulator/PVE/
	dh_install

override_dh_missing:
	dh_missing --fail-missing

# dh_systemd_enable watchdog-mux despite it being static to get it installed in
# the correct location/package without manual intervention
override_dh_installsystemd:
	dh_installsystemd -ppve-ha-manager --name watchdog-mux --no-restart-after-upgrade --no-stop-on-upgrade watchdog-mux.service
	# restart LRM first, else single-node clusters with configured HA will deadlock
	dh_installsystemd -ppve-ha-manager --name pve-ha-lrm pve-ha-lrm.service
	dh_installsystemd -ppve-ha-manager --name pve-ha-crm pve-ha-crm.service
